/**
*
* Title: An example program for Debug
*
* Notes: Beware it has a bug
*
**/

#include "stdio.h"

#define MAX_LINE_LENGTH 256

typedef struct node
{
  struct node *before;
  char *line;
  struct node *after;
} NODE;

NODE *root = 0;
NODE *getnode();

FILE *fpin, *fpout;

main(argc ,argv)
int argc;
char *argv[];
{
  if (argc != 3) error("Bad parameter line");

  if ((fpin  = fopen(argv[1], "r")) == NULL)
    error("Unable to open input file");

  if ((fpout = fopen(argv[2], "w")) == NULL)
    error("Unable to open output file");

  sortlines();

  putnode(root);

  printf("Sorting done\n");
  getch();
  exit(0);
}

sortlines()
{
  NODE *nodeptr;
  NODE *newnode;

  if ((root = getnode()) == 0) error("File is empty");

  while (newnode = getnode())
  {
    nodeptr = root;

    for (;;)
    {
      if (strcmp(newnode->line, nodeptr->line) < 0)
      {
        if (nodeptr->before)
          nodeptr = nodeptr->before;
        else
        {
          nodeptr->before = newnode;
          break;
        }
      }
      else
      {
        if (nodeptr->after)
          nodeptr = nodeptr->after;
        else
        {
          nodeptr->after = newnode;
          break;
        }   
      }
    }
  }
}

putnode(nodeptr)
NODE *nodeptr;
{
  putnode(nodeptr->before);
  fputs(nodeptr->line, fpout);
  free(nodeptr->line);
  putnode(nodeptr->after);
  free(nodeptr);
}

NODE *
getnode()
{
  NODE *nodeptr = 0;
  char buffer[MAX_LINE_LENGTH + 1];

  if (fgets(buffer, MAX_LINE_LENGTH, fpin))
  {
    nodeptr = (NODE *)malloc(sizeof(NODE));
    nodeptr->before = 0;
    nodeptr->line   = (char *)malloc(strlen(buffer) + 1);
    nodeptr->after  = 0;
    strcpy(nodeptr->line, buffer);
  }

  return (nodeptr);
}

error(text)
char text[];
{
  printf("%s\n", text);
  getch();
  exit(1);
}
