
#include "example.h"
#include <portab.h>
#include <gemlib.h>
#include <osbind.h>

#define ROOT 0
#define MAX_DEPTH 8

/* Please include the .RSC file in same folder as this program */

main()
{
   OBJECT *tree;
   char input_text[14];  /* This is an array for entered text */

   appl_init();          /* Tells AES its about to be used. */

    /* We must now load resource file using the AES rsrc_load function */
   
   if (!rsrc_load("example.rsc"))
   {
        /* If not found display alert box and then abort. */

      form_alert(1, "[0][Cannot find example.rsc file|Terminating ...][OK]");
      exit(1);
   }

   rsrc_gaddr(0, EXAMPLE1, &tree); /* get address of dialog tree */

   input_text[0] = '\0'; /* initial position for cursor */

    /*  Make the TEDINFO string pointer point to your input array.*/
   ((TEDINFO *)tree[TEXTNAME].ob_spec)->te_ptext = (long)input_text;

    /* set the length of the maximum text length. */
   ((TEDINFO *)tree[TEXTNAME].ob_spec)->te_txtlen = 13;

   hndl_dialog(tree); /* Call routine to handle the dialog entry. */

   appl_exit();    /* Terminate AES */
}

/* This function centres and then displays your dialog. */

hndl_dialog(tree)
OBJECT *tree;
{
   WORD cx, cy, cw, ch;

    /* Last four coordinates are calculated so that when displayed
       the dialog appears in the center of the screen. */

   form_center(tree, &cx, &cy, &cw, &ch);

    /* Initialise AES to prepare it for a dialog. */
   
   form_dial(FMD_START, cx, cy, cw, ch, 0,0,0,0);

    /* Draw the dialog. */

   objc_draw(tree, ROOT, MAX_DEPTH, cx, cy, cw, ch);

    /* Form_do will not return until the exit button is selected. */

   form_do(tree, TEXTNAME);  /* TEXTNAME is the first (only) editable field */

    /* Tell the AES to redraw the screen area behind dialog */

   form_dial(FMD_FINISH, cx, cy, cw, ch, 0,0,0,0);
}
