/**
*
* name          assert -- program validity check
*
* synopsis      assert(x);
*               
* description   This macro tests a program validity assertion and
*               prints a message on stderr if the assertion is false.
*               The x argument can be any expression that yields a
*               truth value.
*
*               Note that the macro generates no code if the NDEBUG symbol
*               is defined.  Also note that the error message is actually
*               generated by the function _assert.
*
**/
#ifndef NDEBUG
#define assert(x) {if(x); else _assert("x",__FILE__,__LINE__);}
#else
#define assert(exp)
#endif

#ifndef NARGS
extern void _assert(char *, char *, int);
#else
extern void _assert();
#endif

/**
*
* Define NULL if it's not already defined
*
*/
#ifndef NULL
#if SPTR
#define NULL 0                  /* null pointer value */
#else
#define NULL 0L
#endif
#endif
