' Program to test and illustrate TOS 1.4 ('Rainbow TOS') calls.
' These features are also available under TOS 1.6 ('STE TOS').
'
' Calling these routines on machines with pre-1.4 ROMs will produce,
' at best, unpredictable effects and should be avoided.

LIBRARY "gemaes"
DEFINT a-z
version=PEEKW(PEEKL(GB+4))
PRINT "This is AES version ";hex$(version)
IF version<&h130 THEN PRINT "ROMs too old":STOP


' allows an application to read the AESs shell internal buffer
' a sub-program which is passed a long address into which the buffer
' is copied and a length, for the maximum bytes to copy. The length
' should not be more than 1024 bytes
DIM buffer(512)
buf&=VARPTR(buffer(0))
SHEL_GET buf&,1024
DO
	i=PEEKB(buf&)
	IF i=26 THEN EXIT LOOP
	PRINT CHR$(i);
	INCR buf&
LOOP


' allows the AESs shell buffer (shown above) to be set
' Only use this call if you are sure what you are doing as the Desktop
' relies heavily on the buffer being 'sensible'
buf&=VARPTR(buffer(0))
SHEL_PUT buf&,1024


' the new file selector call, similar to old one but supports
' an additional string parameter which can be up to 30 characters
' which will be displayed at the top of the selector
path$="A:\*.*"
name$="TEST"
prompt$="New BASIC Library Test"
FSEL_EXINPUT path$,name$,result,prompt$
PRINT path$,name$,result


' this AES call closes and deletes all windows and restores mouse
' control. It should only be used with extreme care from BASIC in order
' to avoid confusing the runtime system. It is a parameter-less
' sub-program.

' WIND_NEW		'not actually called as will crash both BASIC and Editor.

