/* Simple ATR -> XLD converter
 * Companion program for EmuXL, the Atari 8-bit emulator
 * for Atari Falcon030/TT030.
 * (c) 1998 Draco
 * You have to live with it until
 * I develop a decent (bidirectional) converter
 * for Atari 8-bit disk images.
 */

#include <stdio.h>
#include <string.h>
#include <osbind.h>

int main(short argc, char * argv[])
{
	char name[512];
	char *buf, *cp, *p2;
	short file, spt, slen, i, trk;
	long bytes;

	if (argc == 1) {
		Cconws("Simple ATR -> XLD converter\r\n");
		return 0;
	}

	strcpy(name, argv[1]);

	buf = (char *)Mxalloc(184336L, 3);

	if (buf == NULL) {
		Cconws("Out of memory?\r\n");
		return -1;
	}

	if ((file = Fopen(name, 0)) < 0) {
		Cconws("Can't open file\r\n");
		Mfree(buf);
		return file;
	}

	bytes = Fread(file, 184336L, buf);
	(void)Fclose(file);

	trk = 40;
	spt = 18;
	slen = 128;

	switch(bytes) {
		case 92176:	break;
		case 133136:	spt = 26; break;
		case 183952:
		case 184336:	slen = 256; break;
		default:
			Cconws("Unsupported density\r\n");
			return -1;
			break;
	}

	p2 = strrchr(name, '\\');
	if ((long)p2)
		p2++;
	else
		p2 = name;

	cp = strrchr(p2, '.');
	if ((long)cp)
		strcpy(cp, ".xld");
	else
		strcat(p2, ".xld");

	*(long *)buf = *(long *)"EXLD";

	for(i = 4; i < 16; i++)
		buf[i] = 0x00;

	buf[4] = trk;
	buf[6] = (char) (spt >> 8);
	buf[7] = (char) (spt & 0x00ff);
	buf[9] = (bytes == 92176L) ? 0x00 : 0x04;
	buf[10] = (char) (slen >> 8);
	buf[11] = (char) (slen & 0x00ff);
	buf[12] = 0xff;

	if ((file = Fcreate(name, 0)) < 0) {
		Cconws("Can't open destination\r\n");
		Mfree(buf);
		return file;
	}

	(void)Fwrite(file, 16L, buf);

	cp = buf + 16;

	if (slen == 128) {
		(void)Fwrite(file, 384L, cp);
		cp += 384;
	} else {
		if (bytes == 184336L) {
			(void)Fwrite(file, 768L, cp);
			cp += 768;
		} else {
			for (i = 1; i < 4; i++) {
				(void)Fwrite(file, 256L, cp);
				cp += 128;
			}
		}
	}

	(void)Fwrite(file, bytes - (long)(cp-buf), cp);
	(void)Fclose(file);
	Mfree(buf);
	return 0;
}